/* GCC */

#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <cmath>
#include <stdint.h>
#include <utility>
#include <cstring>
#include <string>
using namespace std;

#define NAME "privat"

#define X first
#define Y second
#define MP(x, y) make_pair((x), (y))

typedef vector<vector<int> > mtx;
const int Up = 1, Right = 2, End = 3;

int main()
{
    freopen(NAME ".in", "r", stdin);
    freopen(NAME ".out", "w", stdout);


    int m, n;

    mtx vals, dp, path;
    scanf("%d%d", &m, &n);

    dp.resize(m, vector<int>(n));
    path.resize(m, vector<int>(n));

    for (int i =0; i < m; ++i)
    {
        vals.push_back(vector<int>());
        for (int j = 0; j < n; ++j)
        {
            int t;
            scanf("%d", &t);
            vals[i].push_back(t);
        }
    }

    for (int i = 0; i < n; ++i) {
        dp[0][i] = vals[0][i];
        path[0][i] = End;
    }

    for (int i = 0; i < m; ++i) {
        dp[i][n-1] = vals[i][n-1];
        path[i][n-1] = End;
    }

    for (int i = 1; i < m; ++i) {
        for (int j = n-2; j>=0;--j) {
            int y = i-1, x = j;
            path[i][j] = Up;

            if (dp[y][x] < dp[y+1][x+1]) {
                ++y;
                ++x;
                path[i][j] = Right;
            }

            int profit = 0;

            switch(path[y][x]) {
            case Up:
                profit = dp[y-1][x];
                break;
            case Right:
                profit = dp[y][x+1];
                break;
            }

            dp[i][j] = profit + vals[i][j];
        }
    }

    int profit1 = 0, profit2 = 0;
    bool set1=false, set2= false;

    int y = m-1, x = 0;
    vector<char> pth;

    while (path[y][x] != End) {
        switch (path[y][x]) {
        case Up:
            --y;
            pth.push_back('u');
            break;
        case Right:
            ++x;
            pth.push_back('r');
            break;
        }

        if (!set1) {
            profit1 = dp[y][x];
            set1 = true;
            continue;
        }
        if (!set2) {
            profit2 = dp[y][x];
            set2 = true;
            continue;
        }
    }

    printf("%d %d\n", profit1, profit2);
    for (int i = 0;i < (int)pth.size(); ++i) {
        printf("%c", pth[i]);
    }
    printf("\n");

    return 0;
}
