/* GCC */
#include <fstream>
#include <string>
#include <iomanip>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;
int n, tmp, c_size, c[8], vmin, v2;
vector<int> gr[2000];
vector<vector<int> > cs[9];
bool uc[2000] = {}, u[2000], conn[2000][2000];

int dfs_is_ok(int v)
{
    int cnt(1), to;
    u[v] = true;
    for(int i = 0; i < gr[v].size(); ++i)
    {
        to = gr[v][i];
        if(!uc[to] && !u[to])
            cnt += dfs_is_ok(gr[v][i]);
    }
    return cnt;
}

bool is_ok(void)
{
    for(int i = 0; i + 2 < c_size; ++i)
        for(int j = i + 2; j < (i == 0 ? c_size - 1 : c_size); ++j)
            if(conn[c[i]][c[j]])
                return false;
    for(int i = 0; i < n; ++i)
        if(!uc[i])
        {
            for(int i = 0; i < n; ++i)
                u[i] = false;
            return (dfs_is_ok(i) + c_size) == n;
        }
    return true;
}

void solve(int depth, int v)
{
    int to;
    c[depth] = v, uc[v] = true;
    if(depth == 1)
        v2 = v;
    if(depth == c_size - 1)
    {
        if(conn[v][c[0]] && v2 < v && is_ok())
        {
            vector<int> vec(c_size);
            for(int i = 0; i < c_size; ++i)
                vec[i] = c[i];
           // sort(vec.begin(), vec.end());
            cs[c_size].push_back(vec);
        }
    }
    else
    {
        for(int i = 0; i < gr[v].size(); ++i)
        {
            to = gr[v][i];
            if(depth > 0 && uc[to] && to != c[depth - 1])
                break;
            if(to < vmin || uc[to])
                continue;
            solve(depth + 1, to);
        }
    }
    uc[v] = false;
}

inline bool comp(const vector<int>& v1, const vector<int>& v2)
{
    return lexicographical_compare(v1.begin(), v1.end(), v2.begin(), v2.end());
}

int main(void)
{
    ios_base::sync_with_stdio(false);
    ifstream in("solid.in");
    in >> n;
    in.get();
    for(int i = 0; i < n; ++i, in.get())
        while(in.peek() != '\n' && in.good())
        {
            in >> tmp;
            --tmp;
            gr[i].push_back(tmp);
            conn[i][tmp] = conn[tmp][i] = true;
        }
    in.close();
    for(c_size = 3; c_size < 9; ++c_size)
        for(vmin = 0; vmin + c_size <= n; ++vmin)
            solve(0, vmin);
    ofstream out("solid.out");
    for(c_size = 3; c_size < 9; ++c_size)
    {
        sort(cs[c_size].begin(), cs[c_size].end(), comp);
        for(int i = 0; i < cs[c_size].size(); ++i)
            for(int j = 0; j < cs[c_size][i].size(); ++j)
                out << cs[c_size][i][j] + 1 << (j == cs[c_size][i].size() - 1 ? '\n' : ' ');
    }
    out.close();
    return 0;
}
